Index: trunk/source/Lib/TLibRenderer/TRenModel.cpp
===================================================================
--- trunk/source/Lib/TLibRenderer/TRenModel.cpp	(revision 1387)
+++ trunk/source/Lib/TLibRenderer/TRenModel.cpp	(revision 1396)
@@ -216,9 +216,11 @@
 Void
 #if H_3D_VSO_EARLY_SKIP
-TRenModel::create( Int iNumOfBaseViews, Int iNumOfModels, Int iWidth, Int iHeight, Int iShiftPrec, Int iHoleMargin, Bool bEarlySkip )
+TRenModel::create( Int iNumOfBaseViews, Int iNumOfModels, Int iWidth, Int iHeight, Int iShiftPrec, Int iHoleMargin, Bool bLimOutput, Bool bEarlySkip )
 #else
-TRenModel::create( Int iNumOfBaseViews, Int iNumOfModels, Int iWidth, Int iHeight, Int iShiftPrec, Int iHoleMargin )
-#endif
-{
+TRenModel::create( Int iNumOfBaseViews, Int iNumOfModels, Int iWidth, Int iHeight, Int iShiftPrec, Int iHoleMargin, Bool bLimOutput )
+#endif
+{
+  m_bLimOutput          = bLimOutput; 
+
   m_iNumOfBaseViews     = iNumOfBaseViews;
   m_iNumOfRenModels     = iNumOfModels;
@@ -416,7 +418,17 @@
 
 #if H_3D_VSO_EARLY_SKIP
-  m_apcRenModels[iModelNum]->create( iMode ,m_iWidth, m_iHeight, m_iShiftPrec, m_aaaiSubPelShiftLut, m_iHoleMargin,  bUseOrgRef, iBlendMode, m_bEarlySkip );
+#if RM_INIT_FIX
+  m_apcRenModels[iModelNum]->create( iMode ,m_iWidth, m_iHeight, m_iShiftPrec, m_aaaiSubPelShiftLut, m_iHoleMargin,  bUseOrgRef, ( iMode != 2 )  ? BLEND_NONE : iBlendMode , m_bLimOutput, m_bEarlySkip );
 #else
-  m_apcRenModels[iModelNum]->create( iMode ,m_iWidth, m_iHeight, m_iShiftPrec, m_aaaiSubPelShiftLut, m_iHoleMargin,  bUseOrgRef, iBlendMode );
+  m_apcRenModels[iModelNum]->create( iMode ,m_iWidth, m_iHeight, m_iShiftPrec, m_aaaiSubPelShiftLut, m_iHoleMargin,  bUseOrgRef, iBlendMode, m_bLimOutput, m_bEarlySkip );
+#endif
+
+#else
+
+#if RM_INIT_FIX
+  m_apcRenModels[iModelNum]->create( iMode ,m_iWidth, m_iHeight, m_iShiftPrec, m_aaaiSubPelShiftLut, m_iHoleMargin,  bUseOrgRef, ( iMode != 2 )  ? BLEND_NONE : iBlendMode, m_bLimOutput );
+#else
+  m_apcRenModels[iModelNum]->create( iMode ,m_iWidth, m_iHeight, m_iShiftPrec, m_aaaiSubPelShiftLut, m_iHoleMargin,  bUseOrgRef, iBlendMode, m_bLimOutput );
+#endif
 #endif
 
@@ -470,5 +482,5 @@
 
 Void
-TRenModel::setSingleModel( Int iModelNum, Int** ppiShiftLutLeft, Int** ppiBaseShiftLutLeft, Int** ppiShiftLutRight, Int** ppiBaseShiftLutRight, Int iDistToLeft, TComPicYuv* pcPicYuvRefView )
+TRenModel::setSingleModel( Int iModelNum, Int** ppiShiftLutLeft, Int** ppiBaseShiftLutLeft, Int** ppiShiftLutRight, Int** ppiBaseShiftLutRight, Int iDistToLeft, TComPicYuv* pcPicYuvRefView, Int iEncViewSIdx)
 {
   AOT( iModelNum < 0 || iModelNum > m_iNumOfRenModels );
@@ -486,5 +498,4 @@
     if ( m_aaeBaseViewPosInModel[iBaseViewIdx][iModelNum] != VIEWPOS_INVALID )
     {
-      bAnyRefFromOrg = true;
       m_apcRenModels[iModelNum]->setLRView( m_aaeBaseViewPosInModel[iBaseViewIdx][iModelNum],
         ( bSetupFromOrgVideo ? m_aapiOrgVideoPel   : m_aapiCurVideoPel   ) [iBaseViewIdx],
@@ -495,10 +506,9 @@
   }
 
-  m_apcRenModels[iModelNum]->setup     ( pcPicYuvRefView, ppiShiftLutLeft, ppiBaseShiftLutLeft, ppiShiftLutRight, ppiBaseShiftLutRight, iDistToLeft, false );
-
-  // Setup to Org
-  if ( bAnyRefFromOrg )
-  {
-    // Restore old values
+  // Render
+#if !RM_FIX_SETUP
+  m_apcRenModels[iModelNum]->setupLutAndRef(  pcPicYuvRefView, ppiShiftLutLeft, ppiBaseShiftLutLeft, ppiShiftLutRight, ppiBaseShiftLutRight, iDistToLeft, bAnyRefFromOrg );
+
+  // Setup with actual data  
     for (Int iBaseViewIdx = 0; iBaseViewIdx < m_iNumOfBaseViews; iBaseViewIdx++ )
     {
@@ -514,8 +524,68 @@
       }
     }
-
-    // setup keeping reference rendered from original data
-    m_apcRenModels[iModelNum]->setup     ( pcPicYuvRefView, ppiShiftLutLeft, ppiBaseShiftLutLeft, ppiShiftLutRight, ppiBaseShiftLutRight, iDistToLeft, true );
-  }
+  // Render initial state
+  AOT( m_bLimOutput && m_aaeBaseViewPosInModel[ iEncViewSIdx ][iModelNum] == VIEWPOS_INVALID );
+  m_apcRenModels[iModelNum]->setupInitialState( m_bLimOutput ? m_aaeBaseViewPosInModel[ iEncViewSIdx ][iModelNum] : VIEWPOS_INVALID );  
+
+#else
+  m_apcRenModels[iModelNum]->setupLut(  ppiShiftLutLeft, ppiBaseShiftLutLeft, ppiShiftLutRight, ppiBaseShiftLutRight, iDistToLeft );
+  
+  // Copy yuv to reference if given.
+  AOT( pcPicYuvRefView != NULL && bAnyRefFromOrg );
+  
+  if (pcPicYuvRefView )
+  {
+    m_apcRenModels[iModelNum]->setupRefView( pcPicYuvRefView );
+  }
+
+  m_apcRenModels[iModelNum]->renderAll( ); 
+
+  // pcPicYuvRefView != NULL &&  bAnyRefFromOrg --> invalid combination
+  // pcPicYuvRefView != NULL && !bAnyRefFromOrg --> distortion correct; reference view correct; current view correct
+  // pcPicYuvRefView == NULL &&  bAnyRefFromOrg --> distortion TBD    ; reference view TBD    ; current view TBD
+  // pcPicYuvRefView == NULL && !bAnyRefFromOrg --> distortion TBD    ; reference view TBD    ; current view correct
+
+  if ( pcPicYuvRefView == NULL )
+  {
+    // Update reference view
+    m_apcRenModels[iModelNum]->setStructSynthViewAsRefView();  
+
+    // pcPicYuvRefView != NULL &&  bAnyRefFromOrg --> invalid combination
+    // pcPicYuvRefView != NULL && !bAnyRefFromOrg --> distortion correct; reference view correct; current view correct
+    // pcPicYuvRefView == NULL &&  bAnyRefFromOrg --> distortion TBD    ; reference view correct; current view TBD
+    // pcPicYuvRefView == NULL && !bAnyRefFromOrg --> distortion TBD    ; reference view correct; current view correct
+
+    if ( bAnyRefFromOrg )
+    {    
+      // Update current view and distortion 
+      for (Int iBaseViewIdx = 0; iBaseViewIdx < m_iNumOfBaseViews; iBaseViewIdx++ )
+      {
+        if ( m_aaeBaseViewPosInModel[iBaseViewIdx][iModelNum] != VIEWPOS_INVALID )
+        {
+          m_apcRenModels[iModelNum]->setLRView(
+            m_aaeBaseViewPosInModel[iBaseViewIdx][iModelNum],
+            m_aapiCurVideoPel      [iBaseViewIdx],
+            m_aaiCurVideoStrides   [iBaseViewIdx],
+            m_apiCurDepthPel       [iBaseViewIdx],
+            m_aiCurDepthStrides    [iBaseViewIdx]
+          );
+        }
+      }
+      m_apcRenModels[iModelNum]->renderAll( );
+    }
+    else
+    {
+      // Update to distortion
+      m_apcRenModels[iModelNum]->resetStructError();
+    }
+  }      
+
+  if ( m_bLimOutput )
+  {
+    AOT( m_aaeBaseViewPosInModel[ iEncViewSIdx ][iModelNum] == VIEWPOS_INVALID );
+    Int curViewPosInModel = m_aaeBaseViewPosInModel[ iEncViewSIdx ][iModelNum];    
+    m_apcRenModels[iModelNum]->setLimOutStruct( (curViewPosInModel == VIEWPOS_RIGHT)  ? VIEWPOS_LEFT : VIEWPOS_RIGHT );
+  }  
+#endif
 }
 
@@ -549,5 +619,5 @@
 TRenModel::setupPart ( UInt uiHorOff, Int iUsedHeight )
 {
-  AOT( iUsedHeight > m_iHeight );     
+//  AOT( iUsedHeight > m_iHeight );     
   m_uiHorOff    = uiHorOff; 
   m_iUsedHeight = iUsedHeight; 
@@ -589,6 +659,5 @@
     }
   }
-
-  return ( iDist + (m_iNumOfCurRenModels >> 1) ) / m_iNumOfCurRenModels;
+  return m_iNumOfCurRenModels > 0 ? ( iDist + (m_iNumOfCurRenModels >> 1) ) / m_iNumOfCurRenModels : 0;
 }
 
Index: trunk/source/Lib/TLibRenderer/TRenModel.h
===================================================================
--- trunk/source/Lib/TLibRenderer/TRenModel.h	(revision 1387)
+++ trunk/source/Lib/TLibRenderer/TRenModel.h	(revision 1396)
@@ -53,7 +53,7 @@
   // Creation
 #if H_3D_VSO_EARLY_SKIP
-  Void  create           ( Int iNumOfBaseViews, Int iNumOfModels, Int iWidth, Int iHeight, Int iShiftPrec, Int iHoleMargin, Bool bEarlySkip );
+  Void  create           ( Int iNumOfBaseViews, Int iNumOfModels, Int iWidth, Int iHeight, Int iShiftPrec, Int iHoleMargin, Bool bLimOutput, Bool bEarlySkip );
 #else
-  Void  create           ( Int iNumOfBaseViews, Int iNumOfModels, Int iWidth, Int iHeight, Int iShiftPrec, Int iHoleMargin );
+  Void  create           ( Int iNumOfBaseViews, Int iNumOfModels, Int iWidth, Int iHeight, Int iShiftPrec, Int iHoleMargin, Bool bLimOutput );
 #endif
   Void  createSingleModel( Int iBaseViewNum, Int iContent, Int iModelNum, Int iLeftViewNum, Int iRightViewNum, Bool bUseOrgRef, Int iBlendMode );
@@ -61,5 +61,5 @@
   // Set new Frame
   Void  setBaseView      ( Int iViewNum, TComPicYuv* pcPicYuvVideoData, TComPicYuv* pcPicYuvDepthData, TComPicYuv* pcPicYuvOrgVideoData, TComPicYuv* pcPicYuvOrgDepthData  );
-  Void  setSingleModel   ( Int iModelNum, Int** ppiShiftLutLeft, Int** ppiBaseShiftLutLeft, Int** ppiShiftLutRight, Int** ppiBaseShiftLutRight, Int iDistToLeft, TComPicYuv* pcPicYuvRefView );
+  Void  setSingleModel   ( Int iModelNum, Int** ppiShiftLutLeft, Int** ppiBaseShiftLutLeft, Int** ppiShiftLutRight, Int** ppiBaseShiftLutRight, Int iDistToLeft, TComPicYuv* pcPicYuvRefView, Int curViewIdx = VIEWPOS_INVALID );
 
   // Set horizontal offset
@@ -96,4 +96,5 @@
   Bool   m_bEarlySkip; 
 #endif
+  Bool   m_bLimOutput; 
 
   /// Size of Video and Depth
